SysIdentify

Public Member Functions | Public Attributes | Properties | Private Attributes | List of all members
TwinCatIdent.MeasureData Class Reference

Class for data storage from PLC More...

Inheritance diagram for TwinCatIdent.MeasureData:

## Public Member Functions
| MeasureData ()
| Empty consructor More...
| MeasureData (DataProperties PropData)
| Constructor from base class More...
void | Add (Int32 CommandValue, Int32 FeedbackValue)
| Add measured data More...
void | AddCurrentValue (Int16 CurrentValue)
| Add measured current value More...
void | AddStepResValue (Int32 CommandValue, Int32 FeedbackValue)
| Add measured Step response value More...
MData | GetData ()
| Return actual item in buffer and shift to next item More...
Int16 | GetCurrentValue ()
| Get current value according to PostionCurrent More...
MData | GetStepResValue ()
| Get step response value according to PositionStepRes More...
MData | GetOrganizedData ()
| Return actual item in buffer and shift to next item More...
Int32 [] | GetAllCommandData ()
| Returns all command values in one row vector More...
Int32 [] | GetAllFeedbackData ()
| Returns all feedback values in one row vector from Identification More...
short [] | GetAllCurrentData ()
| Returns all current values in one row vector from Identification More...
Int32 [] | GetAllStepResCommandData ()
| Returns all command values in one row vector from Step response More...
Int32 [] | GetAllStepResFeedbackData ()
| Returns all feedback values in one row vector from Step response (See also GetAllStepResFeedbackData()) More...
double [] | GetStepResTimeAxis ()
| Get time axis for step response (See also GetAllStepResFeedbackData()) More...
Int32 [][] | GetOrganizedInterestCommandData ()
| Return all command data in matrix[m*n], m = number of repeat, n = number of values in time of sampling input signal More...
Int32 [][] | GetOrganizedInterestFeedbackData ()
| Return all command data in matrix[m*n], m = number of repeat, n = number of values in time of sampling input signal More...
Int32 [] | GetRowOrganizedCommandData (int NumRow)
| Return one row of command data from matrix[m*n], m = number of repeat, n = number of values in time of sampling with base time. Return NumRow-th period command data of input signal More...
Int32 [] | GetRowOrganizedFeedbackData (int NumRow)
| Return one row of feedback data from matrix[m*n], m = number of repeat, n = number of values in time of sampling with base time. Return NumRow-th period feedback data of input signal More...
Int32 [] | GetRowOrganizedInterestCommandData (int NumRow)
| Return one row of command data from matrix[m*n], m = number of repeat, n = number of values in time of sampling input signal. Return NumRow-th period command data of input signal More...
Int32 [] | GetRowOrganizedInterestFeedbackData (int NumRow)
| Return one row of feedback data from matrix[m*n], m = number of repeat, n = number of values in time of sampling input signal. Return NumRow-th period feedback data of input signal More...
int | Count ()
| Count of values from Identification More...
int | CountOneRaw ()
| Count of values in one set of input signal (one set of repeat) More...
int | CountStepRes ()
| Count of values from Step response More...
string | GetSaveName ()
| Get name for saved item More...
void | SaveData (string Path)
| Save measured data More...
Public Member Functions inherited from TwinCatIdent.DataProperties
| DataProperties ()
| Constructor More...
| DataProperties (DataProperties PropData)
| Constructor from DataProperties More...
double | GetScale ()
| Get relevant scale according to ControlMode More...
void | SaveSettingsData (string Path)
| Save settings More...

## Public Attributes
List< Int16 > | iCurrentValue
| List of Current data More...
List< MData > | iStepResValue
| List of Step response data More...
int | Position
| position for iData More...
int | PositionOrganized
| position for iOrganizedData - individual samples More...
int | IndexRepeatGet
| position for iOrganizedData - count of repeat More...
int | PostionCurrent
| Position for current values list More...
int | PositionStepRes
| Position for Step response values list More...

## Properties
new string | AmsNetId`[get]`
| Get AMS NET ID of target More...
new int | AdsPort`[get]`
| Get ADS Port of target More...
new string | PathExtGen`[get]`
| Get path into external generator in PLC More...
new eUnits | Units`[get]`
| Get path into external generator in PLC More...
new string | NameInputSignal`[get]`
| Get name of input signal for identification More...
new int | IdInputSignal`[get]`
| Get ID of input signal for identification More...
new Double | PeriodInputSignal`[get]`
| Get period of input signal in seconds[s] More...
new uint | LengthInputSignal`[get]`
| Get length of input signal (number samples of input signal) More...
new uint | CountRepeat`[get]`
| Get number of repeat input signal More...
new double | AmplitudeInputSignal`[get]`
| Get amplitude of input signal More...
new double | AmplAuxMove`[get]`
| Amplitude of auxiliary movement [in the appropriate units according to mode control] (suppression of friction) More...
new double | FreqAuxMove`[get]`
| Frequency of auxiliary movement in Hz (suppression of friction) More...
new eControlMode | ControlMode`[get]`
| Get Control mode: More...
new DateTime | DateTimeMd`[get]`
| Get date ant time of measuring More...
new bool | IsLinear`[get]`
| Get linear type of motor More...
new double | xScale`[get]`
| Get scale for position mode More...
new double | vScale`[get]`
| Get scale for velocity mode More...
new double | FeedConstant`[get]`
| Get scale for velocity mode More...
new double | TaskTime`[get]`
| Get base time of PLC task More...
new string | NameAxis`[get]`
| Get name of axis More...
new double | StepPreTrigger`[get]`
| Get pre-trigger time of step response [s] More...
new double | StepTime`[get]`
| Get duration of step response [s] More...
new double | StepInitLevel`[get]`
| Get initial level of step response [X] More...
new double | StepFinalLevel`[get]`
| Get final level of step response [X] More...
UInt32 | LengthData`[get]`
| Length of data in matrix [m*n], m = number of repeat, n = number of samples in one period input signal. LengthInterestData = n Length data from one period of input signal More...
UInt32 | LengthInterestData`[get]`
| Length of data in matrix [m*n], m = number of repeat, n = number of samples in one period input signal in time of sampling. LengthInterestData = n Length data from one period of input signal More...
int | ID`[get, set]`
| Get/Set Id of this data set. More...
Properties inherited from TwinCatIdent.DataProperties
string | AmsNetId`[get, set]`
| Get/Set AMS NET ID of target More...
int | AdsPort`[get, set]`
| Get/Set ADS Port of target More...
string | sAdsPort`[get, set]`
| Get/Set ADS Port of target (conversion to/from string) More...
string | PathExtGen`[get, set]`
| Get path into external generator in PLC More...
eUnits | Units`[get, set]`
| Get/Set path into external generator in PLC More...
int | intUnits`[get, set]`
| Get/Set path into external generator in PLC (conversion to/from int) More...
string | NameInputSignal`[get, set]`
| Get name of input signal for identification More...
int | IdInputSignal`[get, set]`
| Get/Set ID of input signal for identification More...
Double | PeriodInputSignal`[get, set]`
| Get/Set period of input signal in seconds[s] More...
string | sPeriodInputSignal`[get, set]`
| Get/Set period of input signal in secondsms More...
uint | LengthInputSignal`[get, set]`
| Get length of input signal (number samples of input signal) More...
UInt16 | CountRepeat`[get, set]`
| Get/Set count repeat of sequence for indentification More...
string | sCountRepeat`[get, set]`
| Get/Set count repeat of sequence for indentification (conversion to/from string) More...
double | AmplitudeInputSignal`[get, set]`
| Get/Set amplitude of input signal [X] More...
string | sAmplitudeInputSignal`[get, set]`
| Get/Set amplitude of input signalX More...
double | AmplAuxMove`[get, set]`
| Amplitude of auxiliary movement [X] (suppression of friction) More...
string | sAmplAuxMove`[get, set]`
| Amplitude of auxiliary movement X More...
double | FreqAuxMove`[get, set]`
| Frequency of auxiliary movement in Hz (suppression of friction) More...
string | sFreqAuxMove`[get, set]`
| Amplitude of auxiliary movement X More...
eControlMode | ControlMode`[get, set]`
| Get/Set Control mode: More...
int | intControlMode`[get, set]`
| Get/Set Control mode: (conversion to/from int) More...
DateTime | DateTimeMd`[get, set]`
| Get/Set date ant time of measuring More...
string | sDateTime`[get, set]`
| Get/Set date ant time of measuring (conversion to/from string) More...
bool | IsLinear`[get, set]`
| Get/Set liner motor type More...
double | xScale`[get, set]`
| Get/Set scale for position mode More...
string | sxScale`[get, set]`
| Get/Set scale for position mode (conversion to/from string) More...
double | vScale`[get, set]`
| Get/Set scale for velocity mode More...
string | svScale`[get, set]`
| Get/Set scale for velocity mode (conversion to/from string) More...
double | FeedConstant`[get, set]`
| Get/Set feed constant More...
string | sFeedConstant`[get, set]`
| Get/Set feed constant (conversion to/from string) More...
double | TaskTime`[get, set]`
| Get/Set cyclus time of PLC task [s] More...
string | sTaskTime`[get, set]`
| Get/Set cyclus time of PLC task ms More...
string | NameAxis`[get, set]`
| Get/Set name of axis More...
double | StepPreTrigger`[get, set]`
| Get/Set pre-trigger time of step response [s] More...
string | sStepPreTrigger`[get, set]`
| Get/Set pre-trigger time of step response s More...
double | StepTime`[get, set]`
| Get/Set duration of step response [s] More...
string | sStepTime`[get, set]`
| Get/Set duration of step response s More...
double | StepInitLevel`[get, set]`
| Get/Set initial level of step response [X] More...
string | sStepInitLevel`[get, set]`
| Get/Set initial level of step response X More...
double | StepFinalLevel`[get, set]`
| Get/Set final level of step response [X] More...
string | sStepFinalLevel`[get, set]`
| Get/Set final level of step response X More...
string | Notes`[get, set]`
| Get/Set Notes More...
int | LengthWindow`[get, set]`
| Get/Set Length of window for computing BodePlot More...
string | sLengthWindow`[get, set]`
| Get/Set length of window for computing BodePlot (conversion to/from string) More...
eModeAnalysis | ModeSpectAnalys`[get, set]`
| Get/Set Mode of spectral analysis for computing BodePlot More...
int | intModeSpectAnalys`[get, set]`
| Get/Set Mode of spectral analysis for computing BodePlot (conversion to/from int) More...
bool | CheckPhaseOverflow`[get, set]`
| Get/Set check phase overflow over +/- 180 degrees More...
int | OffsetIOdata`[get, set]`
| Offset of input/output data. If offset is positive input data are shifted forward. If offset is negative input data are shifted backward. More...
string | sOffsetIOdata`[get, set]`
| Offset of input/output data. If offset is positive input data are shifted forward. If offset is negative input data are shifted backward. (conversion to/from string) More...
double | AllowedPositionRange`[get, set]`
| Allowed position range More...
string | sAllowedPositionRange`[get, set]`
| Allowed position range X More...
bool | EnablePositionRangeCheck`[get, set]`
| Enable position range check More...
Int16 | AllowedTorqueRangeIdent`[get, set]`
| Allowed torque range during identification [°%] More...
string | sAllowedTorqueRangeIdent`[get, set]`
| Allowed torque range during identification % More...
bool | EnableTorqueRangeCheckIdent`[get, set]`
| Enable torque range check during identification More...
Int16 | AllowedTorqueRangeStRes`[get, set]`
| Allowed torque range during step response [°%] More...
string | sAllowedTorqueRangeStRes`[get, set]`
| Allowed torque range during identification % More...
bool | EnableTorqueRangeCheckStRes`[get, set]`
| Enable torque range check during step response More...

## Private Attributes
List< MData > | iData
| List of measured data More...
List< MData > [] | iOrganizedData
| List of measured data in matrix More...
int | i_ID = -1
| Unique ID of curve set. If i_ID = -1, this value is uninitialized. More...
uint | i_LengthData
| Length of data in matrix [m*n], m = number of repeat, n = number of samples in one period input signal catched in time of sampling PLC task. LengthInterestData = n More...
uint | i_LengthInterestData
| Length of data in matrix [m*n], m = count of repeat, n = number of samples in one period input signal catched in time of sampling input signal. LengthInterestData = n More...
int | IndexRepeatSet

## Additional Inherited Members
Static Public Member Functions inherited from TwinCatIdent.DataProperties
static DataProperties | LoadSettingsData (string Path)
| Load settings data from file to class More...
static DataProperties | LoadProfileData (string Path)
| Load motion profile data from file to class More...

## Detailed Description

Class for data storage from PLC

## Constructor & Destructor Documentation

## ◆ MeasureData() [1/2]

TwinCatIdent.MeasureData.MeasureData | ( |  | ) |

Empty consructor

## ◆ MeasureData() [2/2]

TwinCatIdent.MeasureData.MeasureData | ( | DataProperties | PropData | ) |

Constructor from base class

Parameters

  PropData |

## Member Function Documentation

## ◆ Add()

void TwinCatIdent.MeasureData.Add | ( | Int32 | CommandValue,
|  | Int32 | FeedbackValue
| ) |  |

Add measured data

## ◆ AddCurrentValue()

void TwinCatIdent.MeasureData.AddCurrentValue | ( | Int16 | CurrentValue | ) |

Add measured current value

Parameters

  CurrentValue |

## ◆ AddStepResValue()

void TwinCatIdent.MeasureData.AddStepResValue | ( | Int32 | CommandValue,
|  | Int32 | FeedbackValue
| ) |  |

Add measured Step response value

Parameters

  CommandValue |
  FeedbackValue |

## ◆ Count()

int TwinCatIdent.MeasureData.Count | ( |  | ) |

Count of values from Identification

Returns

## ◆ CountOneRaw()

int TwinCatIdent.MeasureData.CountOneRaw | ( |  | ) |

Count of values in one set of input signal (one set of repeat)

Returns

## ◆ CountStepRes()

int TwinCatIdent.MeasureData.CountStepRes | ( |  | ) |

Count of values from Step response

Returns

## ◆ GetAllCommandData()

Int32 [] TwinCatIdent.MeasureData.GetAllCommandData | ( |  | ) |

Returns all command values in one row vector

Returns

## ◆ GetAllCurrentData()

short [] TwinCatIdent.MeasureData.GetAllCurrentData | ( |  | ) |

Returns all current values in one row vector from Identification

Returns

## ◆ GetAllFeedbackData()

Int32 [] TwinCatIdent.MeasureData.GetAllFeedbackData | ( |  | ) |

Returns all feedback values in one row vector from Identification

Returns

## ◆ GetAllStepResCommandData()

Int32 [] TwinCatIdent.MeasureData.GetAllStepResCommandData | ( |  | ) |

Returns all command values in one row vector from Step response

Returns

## ◆ GetAllStepResFeedbackData()

Int32 [] TwinCatIdent.MeasureData.GetAllStepResFeedbackData | ( |  | ) |

Returns all feedback values in one row vector from Step response (See also GetAllStepResFeedbackData())

Returns

## ◆ GetCurrentValue()

Int16 TwinCatIdent.MeasureData.GetCurrentValue | ( |  | ) |

Get current value according to PostionCurrent

Returns

## ◆ GetData()

MData TwinCatIdent.MeasureData.GetData | ( |  | ) |

Return actual item in buffer and shift to next item

Returns

## ◆ GetOrganizedData()

MData TwinCatIdent.MeasureData.GetOrganizedData | ( |  | ) |

Return actual item in buffer and shift to next item

Returns

## ◆ GetOrganizedInterestCommandData()

Int32 [][] TwinCatIdent.MeasureData.GetOrganizedInterestCommandData | ( |  | ) |

Return all command data in matrix[m*n], m = number of repeat, n = number of values in time of sampling input signal

Returns

## ◆ GetOrganizedInterestFeedbackData()

Int32 [][] TwinCatIdent.MeasureData.GetOrganizedInterestFeedbackData | ( |  | ) |

Return all command data in matrix[m*n], m = number of repeat, n = number of values in time of sampling input signal

Returns

## ◆ GetRowOrganizedCommandData()

Int32 [] TwinCatIdent.MeasureData.GetRowOrganizedCommandData | ( | int | NumRow | ) |

Return one row of command data from matrix[m*n], m = number of repeat, n = number of values in time of sampling with base time. Return NumRow-th period command data of input signal

Parameters

  NumRow | Number of period command data of input signal

Returns

## ◆ GetRowOrganizedFeedbackData()

Int32 [] TwinCatIdent.MeasureData.GetRowOrganizedFeedbackData | ( | int | NumRow | ) |

Return one row of feedback data from matrix[m*n], m = number of repeat, n = number of values in time of sampling with base time. Return NumRow-th period feedback data of input signal

Parameters

  NumRow | Number of period feedback data of input signal

Returns

## ◆ GetRowOrganizedInterestCommandData()

Int32 [] TwinCatIdent.MeasureData.GetRowOrganizedInterestCommandData | ( | int | NumRow | ) |

Return one row of command data from matrix[m*n], m = number of repeat, n = number of values in time of sampling input signal. Return NumRow-th period command data of input signal

Parameters

  NumRow | Number of period command data of input signal

Returns

## ◆ GetRowOrganizedInterestFeedbackData()

Int32 [] TwinCatIdent.MeasureData.GetRowOrganizedInterestFeedbackData | ( | int | NumRow | ) |

Return one row of feedback data from matrix[m*n], m = number of repeat, n = number of values in time of sampling input signal. Return NumRow-th period feedback data of input signal

Parameters

  NumRow | Number of period feedback data of input signal

Returns

## ◆ GetSaveName()

string TwinCatIdent.MeasureData.GetSaveName | ( |  | ) |

Get name for saved item

Returns

## ◆ GetStepResTimeAxis()

double [] TwinCatIdent.MeasureData.GetStepResTimeAxis | ( |  | ) |

Get time axis for step response (See also GetAllStepResFeedbackData())

Returns

## ◆ GetStepResValue()

MData TwinCatIdent.MeasureData.GetStepResValue | ( |  | ) |

Get step response value according to PositionStepRes

Returns

## ◆ SaveData()

void TwinCatIdent.MeasureData.SaveData | ( | string | Path | ) |

Save measured data

Parameters

  Path | Path for new file with measured data

## Member Data Documentation

## ◆ i_ID

int TwinCatIdent.MeasureData.i_ID = -1
| private

Unique ID of curve set. If i_ID = -1, this value is uninitialized.

## ◆ i_LengthData

uint TwinCatIdent.MeasureData.i_LengthData
| private

Length of data in matrix [m*n], m = number of repeat, n = number of samples in one period input signal catched in time of sampling PLC task. LengthInterestData = n

## ◆ i_LengthInterestData

uint TwinCatIdent.MeasureData.i_LengthInterestData
| private

Length of data in matrix [m*n], m = count of repeat, n = number of samples in one period input signal catched in time of sampling input signal. LengthInterestData = n

## ◆ iCurrentValue

List<Int16> TwinCatIdent.MeasureData.iCurrentValue

List of Current data

## ◆ iData

List<MData> TwinCatIdent.MeasureData.iData
| private

List of measured data

## ◆ IndexRepeatGet

int TwinCatIdent.MeasureData.IndexRepeatGet

position for iOrganizedData - count of repeat

## ◆ iOrganizedData

List<MData> [] TwinCatIdent.MeasureData.iOrganizedData
| private

List of measured data in matrix

## ◆ iStepResValue

List<MData> TwinCatIdent.MeasureData.iStepResValue

List of Step response data

## ◆ Position

int TwinCatIdent.MeasureData.Position

position for iData

summary> index for storing data to matrix(interesting values) /summary>

## ◆ PositionOrganized

int TwinCatIdent.MeasureData.PositionOrganized

position for iOrganizedData - individual samples

## ◆ PositionStepRes

int TwinCatIdent.MeasureData.PositionStepRes

Position for Step response values list

## ◆ PostionCurrent

int TwinCatIdent.MeasureData.PostionCurrent

Position for current values list

## Property Documentation

## ◆ AdsPort

new int TwinCatIdent.MeasureData.AdsPort
| get

Get ADS Port of target

## ◆ AmplAuxMove

new double TwinCatIdent.MeasureData.AmplAuxMove
| get

Amplitude of auxiliary movement [in the appropriate units according to mode control] (suppression of friction)

## ◆ AmplitudeInputSignal

new double TwinCatIdent.MeasureData.AmplitudeInputSignal
| get

Get amplitude of input signal

## ◆ AmsNetId

new string TwinCatIdent.MeasureData.AmsNetId
| get

Get AMS NET ID of target

## ◆ ControlMode

new eControlMode TwinCatIdent.MeasureData.ControlMode
| get

Get Control mode:

- NoneControl
- PositionControl
- TorqueControl
- VelocityControl

## ◆ CountRepeat

new uint TwinCatIdent.MeasureData.CountRepeat
| get

Get number of repeat input signal

## ◆ DateTimeMd

new DateTime TwinCatIdent.MeasureData.DateTimeMd
| get

Get date ant time of measuring

## ◆ FeedConstant

new double TwinCatIdent.MeasureData.FeedConstant
| get

Get scale for velocity mode

## ◆ FreqAuxMove

new double TwinCatIdent.MeasureData.FreqAuxMove
| get

Frequency of auxiliary movement in Hz (suppression of friction)

## ◆ ID

int TwinCatIdent.MeasureData.ID
| get set

Get/Set Id of this data set.

## ◆ IdInputSignal

new int TwinCatIdent.MeasureData.IdInputSignal
| get

Get ID of input signal for identification

## ◆ IsLinear

new bool TwinCatIdent.MeasureData.IsLinear
| get

Get linear type of motor

## ◆ LengthData

UInt32 TwinCatIdent.MeasureData.LengthData
| get

Length of data in matrix [m*n], m = number of repeat, n = number of samples in one period input signal. LengthInterestData = n Length data from one period of input signal

## ◆ LengthInputSignal

new uint TwinCatIdent.MeasureData.LengthInputSignal
| get

Get length of input signal (number samples of input signal)

## ◆ LengthInterestData

UInt32 TwinCatIdent.MeasureData.LengthInterestData
| get

Length of data in matrix [m*n], m = number of repeat, n = number of samples in one period input signal in time of sampling. LengthInterestData = n Length data from one period of input signal

## ◆ NameAxis

new string TwinCatIdent.MeasureData.NameAxis
| get

Get name of axis

## ◆ NameInputSignal

new string TwinCatIdent.MeasureData.NameInputSignal
| get

Get name of input signal for identification

## ◆ PathExtGen

new string TwinCatIdent.MeasureData.PathExtGen
| get

Get path into external generator in PLC

## ◆ PeriodInputSignal

new Double TwinCatIdent.MeasureData.PeriodInputSignal
| get

Get period of input signal in seconds[s]

## ◆ StepFinalLevel

new double TwinCatIdent.MeasureData.StepFinalLevel
| get

Get final level of step response [X]

## ◆ StepInitLevel

new double TwinCatIdent.MeasureData.StepInitLevel
| get

Get initial level of step response [X]

## ◆ StepPreTrigger

new double TwinCatIdent.MeasureData.StepPreTrigger
| get

Get pre-trigger time of step response [s]

## ◆ StepTime

new double TwinCatIdent.MeasureData.StepTime
| get

Get duration of step response [s]

## ◆ TaskTime

new double TwinCatIdent.MeasureData.TaskTime
| get

Get base time of PLC task

## ◆ Units

new eUnits TwinCatIdent.MeasureData.Units
| get

Get path into external generator in PLC

## ◆ vScale

new double TwinCatIdent.MeasureData.vScale
| get

Get scale for velocity mode

## ◆ xScale

new double TwinCatIdent.MeasureData.xScale
| get

Get scale for position mode

The documentation for this class was generated from the following file:

- C:/Users/matusa.BECKHOFF/Documents/Indentifikacia sustav/System Identification WPF/SysIdentifi/SysIdentifi/TwinCatExtGen.cs